canvas3 = document.getElementById("canvas3"),ctx3 = canvas3.getContext("2d");
canvas4 = document.getElementById("canvas4"),ctx4 = canvas4.getContext("2d");

massrange = document.getElementById("massrange");
initialVx = document.getElementById("velrangex");
initialVy = document.getElementById("velrangey");
initialx = document.getElementById("initialx");
initialy = document.getElementById("initialy");
ranbutton = document.getElementById("randomv");
button = document.getElementById("button");
paused = true;
var particles = [];
var preparticles = [];
var mode = 1;

//define 2Dvector

Vector2 = function(x, y) { this.x = x; this.y = y; };

Vector2.prototype = {
    copy : function() { return new Vector2(this.x, this.y); },
    length : function() { return Math.sqrt(this.x * this.x + this.y * this.y); },
    sqrLength : function() { return this.x * this.x + this.y * this.y; },
    normalize : function() { var inv = 1/this.length(); return new Vector2(this.x * inv, this.y * inv); },
    negate : function() { return new Vector2(-this.x, -this.y); },
    add : function(v) { return new Vector2(this.x + v.x, this.y + v.y); },
    subtract : function(v) { return new Vector2(this.x - v.x, this.y - v.y); },
    multiply : function(f) { return new Vector2(this.x * f, this.y * f); },
    divide : function(f) { var invf = 1/f; return new Vector2(this.x * invf, this.y * invf); },
    dot : function(v) { return this.x * v.x + this.y * v.y; },
};

Vector2.zero = new Vector2(0, 0);
//Vector2.random = new Vector2(Math.random(),Math.random());

//限制一个矢量的大小
function constrain(v,min,max){
    if (v.length()<min){
        v = v.multiply( min/v.length());
    }
    if(v.length()>max){
        v = v.multiply(max/v.length());
    }
    else{
        v = v;
    }
    return v;
};


function particle(x,y)  {
    this.pos = new Vector2(x,y);
    this.vel = new Vector2(0,0);
    this.acc = new Vector2(0,0);
    this.radius = Math.sqrt(10);
    this.mass = 10;
    
    this.update = function(){

        this.pos = this.pos.add(this.vel.multiply(0.01));
        this.vel = this.vel.add(this.acc.multiply(0.01));
    }

    this.show = function(){

        ctx3.beginPath();
        ctx3.arc(this.pos.x,this.pos.y,this.radius,0, Math.PI*2, true);
        ctx3.fillStyle = "cornflowerblue";
        ctx3.fill();
        ctx3.stroke();
    }
    //window.alert(this.pos.x);

    this.attracted = function(target){

        var dir = target.pos.subtract(this.pos);
        var sqL = dir.sqrLength();
        var G  = 10000;
        var force = dir.normalize().multiply(G /sqL*this.mass*target.mass);
        force = constrain(force,0,1000);
        return force.multiply(1/this.mass);
        
    }
}






//备份



function step(){
//备份位置和质量
    for(var i = 0;i<particles.length;i++){
        preparticles[i] = new particle(particles[i].pos.x,particles[i].pos.y);
        preparticles[i].pos = particles[i].pos;
        preparticles[i].mass = particles[i].mass;
    }

    if (mode ==1){
    ctx3.clearRect(0,0,canvas3.width,canvas3.height);
    //initialize
    for(var i = 0;i<particles.length;i++){
        particles[i].acc = Vector2.zero;
        preparticles[i].acc = Vector2.zero
    }

    for (var i =0 ;i<particles.length;i++){

        for (var j =0 ; j<particles.length;j++){
            if(j!=i){
                particles[i].acc = preparticles[i].acc.add(preparticles[i].attracted(preparticles[j]));};
        };
        particles[i].update();
        /*for (var j = 0;j<particles.length;j++){
            if (j!=i){
            var  d = particles[i].pos.subtract(particles[j].pos);
            if( d.length < 10){
                particles[i].pos = particles[i].pos.add(d.normalize().multiply(10).subtract(d));
            }
            }
        }*/


        particles[i].show();
    }}

    if (mode==2){
        ctx3.clearRect(0,0,canvas3.width,canvas3.height);
        //initialize
        for(var i = 0;i<particles.length;i++){
            particles[i].acc = Vector2.zero;
            preparticles[i].acc = Vector2.zero
        }
    
        for (var i =1 ;i<particles.length;i++){
    
            for (var j =0 ; j<particles.length;j++){
                if(j!=i){
                    particles[i].acc = particles[i].acc.add(preparticles[i].attracted(preparticles[j]));};
            };
            particles[i].update();
            particles[i].show();
            console.log(particles[1].pos.x,preparticles[1].pos.x);
            
            
        }
        var l = particles.length;
        ctx4.strokeStyle = "#000000";
        ctx4.fillStyle = "#FFFFFF";
        ctx4.beginPath();
        ctx4.moveTo(preparticles[l-1].pos.x,preparticles[l-1].pos.y);
        ctx4.lineTo(particles[l-1].pos.x,particles[l-1].pos.y);
        ctx4.stroke();

        console.log(preparticles[l-1].pos.x,particles[l-1].pos.x);

        ctx3.beginPath();
        ctx3.arc(particles[0].pos.x,particles[0].pos.y,particles[0].radius,0, Math.PI*2, true);
        ctx3.fillStyle = "red";
        ctx3.fill();
        ctx3.stroke();

        

    }
    //console.log(preparticles[1].acc);
}

function start(){
    window.requestAnimationFrame(start);
    mode = document.getElementById('modelist').value;
   // console.log(mode);
    if (paused){
    ctx3.clearRect(0,0,canvas3.width,canvas3.height);
    for (i =0;i<particles.length;i++){
        particles[i].show();
    }
};
    if (! paused){
    step();
    var l = particles.length;
    console.log(particles[l-1].vel)
    }


}

//interact with user
function windowToCanvas(x,y){
    var bbox = canvas. getBoundingClientRect();
    return{
        x :x-bbox.left,//*(canvas.width/bbox.width),
        y :y-bbox.top//*(canvas.height/bbox.height)
    }
}

function isCursorinCanvas(x,y){
    if(x>canvas3.left && x<canvas3.left+canvas3.width&&
        y>canvas3.top && y<canvas3.top + canvas3.height){
            return ture
        }

    else{return false};
}

massrange.onchange = function(e){
    var l = particles.length;
    particles[l-1].mass = massrange.value;
    particles[l-1].radius = Math.sqrt(massrange.value);
}  

initialVx.onchange = function(e){
    var l = particles.length;
    particles[l-1].vel.x = +initialVx.value;
}

initialVy.onchange = function(e){
    var l = particles.length;
    particles[l-1].vel.y = -initialVy.value;
}

initialx.onchange = function(e){
    var l = particles.length;
    particles[l-1].pos.x = 200 + Number(initialx.value);
    console.log(particles[l-1].pos.x);
}
initialy.onchange = function(e){
    var l = particles.length;
    particles[l-1].pos.y = 200 - initialy.value;
    console.log(particles[l-1].pos.y);
    
}

button.onclick = function(e){
    if (paused){
        paused = false;
        button.value="stop"
    }
    else{
        particles = [];
        ctx3.clearRect(0,0,canvas3.width,canvas3.height);
        ctx4.clearRect(0,0,canvas4.width,canvas3.height);
        paused = true;
        button.value = "start";
        //updateInfo();

    }
};

ranbutton.onclick = function(e){
    if(paused){
    var l = particles.length;
    particles[l-1].vel = new Vector2(Math.random()*5,Math.random()*5);
    console.log(particles[l-1].vel);

        //updateInfo();
    }

    };

/*canvas.onmousedown = function(e){
    var loc = windowToCanvas(e.clientX,e.clientY);
    if( isPointInCircle(loc)&&paused){
        dragging = true;
        mousedown.OffsetX = loc.x - circle.x;
        mousedown.OffsetY = loc.y - circle.y;
    }
    }*/

/*canvas3.addEventListener('click', function(e)
 {
    if  (isCursorinCanvas(e.clientX,e.clientY)){
    window.alert("click on canvas");
    click = ture;
    console.log(click);
}
});*/

canvas3.onclick =function(e){
    if (paused){
    if  (e.offsetX< canvas3.width && e.offsetY <canvas3.height){
        //window.alert("click on canvas");
        particles.push ( new particle(e.offsetX,e.offsetY));
        var l = particles.length;
        particles[l-1].vel =particles[l-1].vel.add( new Vector2(+initialVx.value,-initialVy.value));
        
        //console.log(+initialVx.value+1)
    }
      
}
}

start();




