var layer1 = document.getElementById("layer1"), ctx1 = layer1.getContext("2d");
var layer2 = document.getElementById("layer2"), ctx2 = layer2.getContext("2d");
var canvas4 = document.getElementById("rightcan"),ctx4 = canvas4.getContext("2d");

var radiusrange1 = document.getElementById("radiusrange1");
var radiusrange2 = document.getElementById("radiusrange2");
var angle1 = document.getElementById("angle1");
var angle2 = document.getElementById("angle2");
var length1 = document.getElementById("length1");
var length2 = document.getElementById("length2");
var button = document.getElementById("button");
paused = true;

var timeoutID;

var ball1 = {
    a : Math.PI/6 ,
    m : 40,
    r : 20,
    l : 150,
    a_v : 0,
    a_acc : 0,
    
};

var ball2 = {
    a : Math.PI/6,
    m : 40,
    r : 20,
    l : 100,
    a_v : 0,
    a_acc : 0
};

var g  = 9.8;
var prex2;
var prey2;
var prea1;
var prea2;


// Vector2.js
Vector2 = function(x, y) { this.x = x; this.y = y; };
 
Vector2.prototype = {
    copy : function() { return new Vector2(this.x, this.y); },
    length : function() { return Math.sqrt(this.x * this.x + this.y * this.y); },
    sqrLength : function() { return this.x * this.x + this.y * this.y; },
    normalize : function() { var inv = 1/this.length(); return new Vector2(this.x * inv, this.y * inv); },
    negate : function() { return new Vector2(-this.x, -this.y); },
    add : function(v) { return new Vector2(this.x + v.x, this.y + v.y); },
    subtract : function(v) { return new Vector2(this.x - v.x, this.y - v.y); },
    multiply : function(f) { return new Vector2(this.x * f, this.y * f); },
    divide : function(f) { var invf = 1/f; return new Vector2(this.x * invf, this.y * invf); },
    dot : function(v) { return this.x * v.x + this.y * v.y; }
};
 
Vector2.zero = new Vector2(0, 0);


//欧拉积分 v += acc*dt


    
function draw(){

    ctx1.clearRect(0,0,layer1.width,layer1.height);

    var x1 = layer1.width/2 + ball1.l*Math.sin(ball1.a);
    var y1 = layer1.height/2 + ball1.l*Math.cos(ball1.a);
    var x2 = x1 + ball2.l*Math.sin(ball2.a);
    var y2 = y1 + ball2.l*Math.cos(ball2.a);

    ctx1.strokeStyle = "#000000";
    ctx1.fillStyle = "#FFFFFF";
    ctx1.beginPath();
    ctx1.arc(x1, y1, ball1.r, 0, Math.PI*2, true); 
    ctx1.fillStyle = "cornflowerblue";
    ctx1.fill();
    ctx1.stroke();

    ctx1.beginPath();
    ctx1.moveTo(x1,y1);
    ctx1.lineTo(layer1.width/2,layer1.height/2);
    ctx1.stroke();

    ctx1.beginPath();
    ctx1.arc(x2,y2,ball2.r, 0, Math.PI*2, true);
    ctx1.fillStyle = "cornflowerblue";
    ctx1.fill();
    ctx1.stroke();

    ctx1.beginPath();
    ctx1.moveTo(x2,y2);
    ctx1.lineTo(x1,y1);
    ctx1.stroke();

    
    
    
}


dt = 0.1;

function step() {
    
    //damp
    ball1.a_acc = ball1.a_acc*0.999;
    ball2.a_acc = ball2.a_acc*0.999;

//ball1.a_acc = f1

    function f1(a1,a2,v1,v2){
    var num1  = -g*(2*ball1.m+ball2.m)*Math.sin(a1);
    var num2 = -ball2.m*g*Math.sin(a1-2*a2);
    var num3 = -2*Math.sin(a1-a2)*ball2.m;
    var num4 = v2*v2*ball2.l + v1*v1*ball1.l*Math.cos(a1-a2);
    var num5 = ball1.l*(2*ball1.m+ball2.m-ball2.m*Math.cos(2*a1-2*a2));
    
    return ( num1+num2+num3*num4 )/num5;
    }
//ball2.a_acc = f2
    function f2(a1,a2,v1,v2){
    var num11 = 2*Math.sin(a1-a2);
    var num22 = v1*v1*ball1.l*(ball1.m+ball2.m);
    var num33 = g*(ball1.m+ball2.m)*Math.cos(a1);
    var num44 = v2*v2*ball2.l*ball2.m*Math.cos(a1-a2);
    var num55 = ball2.l*(2*ball1.m+ball2.m-ball2.m*Math.cos(2*a1-2*a2));
  
    return num11*(num22+num33+num44)/num55;
    }

    /* Ouler Method
    ball1.a += ball1.a_v*dt;
    ball1.a_v += ball1.a_acc *dt;
    var x1 = layer1.width/2 + ball1.l*Math.sin(ball1.a);
    var y1 = layer1.height/2 + ball1.l*Math.cos(ball1.a);

    ball2.a += ball2.a_v*dt;
    ball2.a_v += ball2.a_acc *dt;
    x2 = x1 + ball2.l*Math.sin(ball2.a);
    var y2 = y1 + ball2.l*Math.cos(ball2.a);*/

    //RK-4
    var s11 = ball1.a_v;//slop1 for ball1.a
    var s12 = ball2.a_v;//slop1 for ball2.a
    var s13 = f1(ball1.a,ball2.a,ball1.a_v,ball2.a_v);//slop1 for ball1.a_vv
    var s14 = f2(ball1.a,ball2.a,ball1.a_v,ball2.a_v);
    var hy1 = ball1.a + dt/2*s11; //插值
    var hy2 = ball2.a + dt/2*s12;
    var hy3 = ball1.a_v + dt/2*s13;
    var hy4 = ball2.a_v + dt/2*s14;
    var s21 = hy3;
    var s22 = hy4;
    var s23 = f1(hy1,hy2,hy3,hy4);
    var s24 = f2(hy1,hy2,hy3,hy4);
    hy1 = ball1.a + dt/2*s21;
    hy2 = ball2.a + dt/2*s22;
    hy3 = ball1.a_v + dt/2*s23;
    hy4 = ball2.a_v + dt/2*s24;
    var s31 = hy3;
    var s32 =hy4;
    var s33 = f1(hy1,hy2,hy3,hy4);
    var s34 = f2(hy1,hy2,hy3,hy4);
    hy1 = ball1.a + dt*s31;
    hy2 = ball2.a + dt*s32;
    hy3 = ball1.a_v + dt*s33;
    hy4 = ball2.a_v + dt*s34;
    var s41 = hy3;
    var s42 = hy4;
    var s43 = f1(hy1,hy2,hy3,hy4);
    var s44 = f2(hy1,hy2,hy3,hy4);
    ball1.a += dt/6*(s11+2*s21+2*s31+s41);
    ball2.a += dt/6*(s12+2*s22+2*s32+s42);
    ball1.a_v += dt/6*(s13+2*s23+2*s33+s43);
    ball2.a_v += dt/6*(s14+2*s24+2*s34+s44);

    var x1 = layer1.width/2 + ball1.l*Math.sin(ball1.a);
    var y1 = layer1.height/2 + ball1.l*Math.cos(ball1.a);
    var x2 = x1 + ball2.l*Math.sin(ball2.a);
    var y2 = y1 + ball2.l*Math.cos(ball2.a);




    //save the data
    
    ctx2.strokeStyle = "#000000";
    ctx2.fillStyle = "#FFFFFF";
    ctx2.beginPath();
    ctx2.moveTo(prex2,prey2);
    ctx2.lineTo(x2,y2);
    ctx2.stroke();

   /* ctx4.strokeStyle = "#000000";
    ctx4.fillStyle = "#FFFFFF";
    ctx4.beginPath();
    ctx4.moveTo(200+(prea1%(2*Math.PI)-Math.PI)*50,200+(prea2%(2*Math.PI)-Math.PI)*50);
    ctx4.lineTo(200+(ball1.a%(2*Math.PI)-Math.PI)*50,200+(ball2.a%(2*Math.PI)-Math.PI)*50);
    ctx4.stroke();
    console.log(prea1,ball1.a);*/
    
    prex2 =x2;
    prey2 =y2;
    prea1 = ball1.a;
    prea2 = ball2.a;

    draw();

}



//开始循环

/*function start(func) {
    if (timeoutID)
         stop();
    isContinue = true;

    var loop = function() {
        func();
        if (isContinue)
            timeoutID = setTimeout(loop, 10);
    }

    loop();
}
*/

    

function start(){
    window.requestAnimationFrame(start);

    if(!paused){
    step();}
    else{
 
        draw();
    }
    
    
}





function windowTolayer1(x,y){
    var bbox = layer1. getBoundingClientRect();
    return{
        x :x-bbox.left*(layer1.width/bbox.width),
        y :y-bbox.top*(layer1.height/bbox.height)
    }
}

function isPointInCircle(loc){
    context.beginPath();
    context.arc(circle.x,circle.y,circle.radius,0,2*Math.PI);
    return context.isPointInPath(loc.x,loc.y);
}

//事件
radiusrange1.onchange = function(e){
    ball1.m = radiusrange1.value;
    ball1.r = ball1.m/2;

    
}  

radiusrange2.onchange = function(e){
    ball2.m = radiusrange2.value;
    ball2.r = ball2.m/2;
}

angle1.onchange = function(e){
    ball1.a = angle1.value*Math.PI/180;
}
angle2.onchange = function(e){
    ball2.a = angle2.value*Math.PI/180;
}

length1.onchange = function(e){
    ball1.l = length1.value;
}
length2.onchange = function(e){
    ball2.l = length2.value;
}


button.onclick = function(e){
    if(paused == true){
        paused = false;
        button.value = "stop";
    }
    else{
        paused = true;
        button.value = "start"
    }
}

start() ;











